## ocaml 3.12.1

=== asmrun/Makefile ===
#########################################################################
#                                                                       #
#                            Objective Caml                             #
#                                                                       #
#            Xavier Leroy, projet Cristal, INRIA Rocquencourt           #
#                                                                       #
#   Copyright 1999 Institut National de Recherche en Informatique et    #
#   en Automatique.  All rights reserved.  This file is distributed     #
#   under the terms of the GNU Library General Public License, with     #
#   the special exception on linking described in file ../LICENSE.      #
#                                                                       #
#########################################################################

# $Id: Makefile 10287 2010-04-20 15:47:15Z doligez $

include ../config/Makefile

CC=$(NATIVECC)
FLAGS=-I../byterun -DCAML_NAME_SPACE -DNATIVE_CODE \
      -DTARGET_$(ARCH) -DSYS_$(SYSTEM) $(IFLEXDIR)
CFLAGS=$(FLAGS) -O $(NATIVECCCOMPOPTS)
DFLAGS=$(FLAGS) -g -DDEBUG $(NATIVECCCOMPOPTS)
PFLAGS=$(FLAGS) -pg -O -DPROFILING $(NATIVECCPROFOPTS)

COBJS=startup.o main.o fail.o roots.o globroots.o signals.o signals_asm.o \
  misc.o freelist.o major_gc.o minor_gc.o memory.o alloc.o compare.o ints.o \
  floats.o str.o array.o io.o extern.o intern.o hash.o sys.o parsing.o \
  gc_ctrl.o terminfo.o md5.o obj.o lexing.o printexc.o callback.o weak.o \
  compact.o finalise.o custom.o unix.o backtrace.o natdynlink.o debugger.o

ASMOBJS=$(ARCH).o

OBJS=$(COBJS) $(ASMOBJS)
DOBJS=$(COBJS:.o=.d.o) $(ASMOBJS)
POBJS=$(COBJS:.o=.p.o) $(ASMOBJS:.o=.p.o)

all: libasmrun.a all-$(PROFILING)

libasmrun.a: $(OBJS)
	rm -f libasmrun.a
	ar rc libasmrun.a $(OBJS)
	$(RANLIB) libasmrun.a

libasmrund.a: $(DOBJS)
	rm -f libasmrund.a
	ar rc libasmrund.a $(DOBJS)
	$(RANLIB) libasmrund.a

all-noprof:

all-prof: libasmrunp.a

libasmrunp.a: $(POBJS)
	rm -f libasmrunp.a
	ar rc libasmrunp.a $(POBJS)
	$(RANLIB) libasmrunp.a

install: install-default install-$(PROFILING)

install-default:
	cp libasmrun.a $(LIBDIR)/libasmrun.a
	cd $(LIBDIR); $(RANLIB) libasmrun.a

install-noprof:
	rm -f $(LIBDIR)/libasmrunp.a; ln -s libasmrun.a $(LIBDIR)/libasmrunp.a

install-prof:
	cp libasmrunp.a $(LIBDIR)/libasmrunp.a
	cd $(LIBDIR); $(RANLIB) libasmrunp.a

power.o: power-$(SYSTEM).o
	cp power-$(SYSTEM).o power.o

power.p.o: power-$(SYSTEM).o
	cp power-$(SYSTEM).o power.p.o

main.c: ../byterun/main.c
	ln -s ../byterun/main.c main.c
misc.c: ../byterun/misc.c
	ln -s ../byterun/misc.c misc.c
freelist.c: ../byterun/freelist.c
	ln -s ../byterun/freelist.c freelist.c
major_gc.c: ../byterun/major_gc.c
	ln -s ../byterun/major_gc.c major_gc.c
minor_gc.c: ../byterun/minor_gc.c
	ln -s ../byterun/minor_gc.c minor_gc.c
memory.c: ../byterun/memory.c
	ln -s ../byterun/memory.c memory.c
alloc.c: ../byterun/alloc.c
	ln -s ../byterun/alloc.c alloc.c
array.c: ../byterun/array.c
	ln -s ../byterun/array.c array.c
compare.c: ../byterun/compare.c
	ln -s ../byterun/compare.c compare.c
ints.c: ../byterun/ints.c
	ln -s ../byterun/ints.c ints.c
floats.c: ../byterun/floats.c
	ln -s ../byterun/floats.c floats.c
str.c: ../byterun/str.c
	ln -s ../byterun/str.c str.c
io.c: ../byterun/io.c
	ln -s ../byterun/io.c io.c
extern.c: ../byterun/extern.c
	ln -s ../byterun/extern.c extern.c
intern.c: ../byterun/intern.c
	ln -s ../byterun/intern.c intern.c
hash.c: ../byterun/hash.c
	ln -s ../byterun/hash.c hash.c
sys.c: ../byterun/sys.c
	ln -s ../byterun/sys.c sys.c
parsing.c: ../byterun/parsing.c
	ln -s ../byterun/parsing.c parsing.c
gc_ctrl.c: ../byterun/gc_ctrl.c
	ln -s ../byterun/gc_ctrl.c gc_ctrl.c
terminfo.c: ../byterun/terminfo.c
	ln -s ../byterun/terminfo.c terminfo.c
md5.c: ../byterun/md5.c
	ln -s ../byterun/md5.c md5.c
obj.c: ../byterun/obj.c
	ln -s ../byterun/obj.c obj.c
lexing.c: ../byterun/lexing.c
	ln -s ../byterun/lexing.c lexing.c
printexc.c: ../byterun/printexc.c
	ln -s ../byterun/printexc.c printexc.c
callback.c: ../byterun/callback.c
	ln -s ../byterun/callback.c callback.c
weak.c: ../byterun/weak.c
	ln -s ../byterun/weak.c weak.c
compact.c: ../byterun/compact.c
	ln -s ../byterun/compact.c compact.c
finalise.c: ../byterun/finalise.c
	ln -s ../byterun/finalise.c finalise.c
custom.c: ../byterun/custom.c
	ln -s ../byterun/custom.c custom.c
meta.c: ../byterun/meta.c
	ln -s ../byterun/meta.c meta.c
globroots.c: ../byterun/globroots.c
	ln -s ../byterun/globroots.c globroots.c
unix.c: ../byterun/unix.c
	ln -s ../byterun/unix.c unix.c
dynlink.c: ../byterun/dynlink.c
	ln -s ../byterun/dynlink.c dynlink.c
signals.c: ../byterun/signals.c
	ln -s ../byterun/signals.c signals.c
debugger.c: ../byterun/debugger.c
	ln -s ../byterun/debugger.c debugger.c

LINKEDFILES=misc.c freelist.c major_gc.c minor_gc.c memory.c alloc.c array.c \
  compare.c ints.c floats.c str.c io.c extern.c intern.c hash.c sys.c \
  parsing.c gc_ctrl.c terminfo.c md5.c obj.c lexing.c printexc.c callback.c \
  weak.c compact.c finalise.c meta.c custom.c main.c globroots.c unix.c \
  dynlink.c signals.c debugger.c

clean::
	rm -f $(LINKEDFILES)

.SUFFIXES: .S .d.o .p.o

.S.o:
	$(ASPP) -DSYS_$(SYSTEM) -o $*.o $*.S || \
	{ echo "If your assembler produced syntax errors, it is probably unhappy with the"; echo "preprocessor. Check your assembler, or try producing $*.o by hand."; exit 2; }

.S.p.o:
	$(ASPP) -DSYS_$(SYSTEM) $(ASPPPROFFLAGS) -o $*.p.o $*.S

.c.d.o:
	@ if test -f $*.o; then mv $*.o $*.f.o; else :; fi
	$(CC) -c $(DFLAGS) $<
	mv $*.o $*.d.o
	@ if test -f $*.f.o; then mv $*.f.o $*.o; else :; fi

.c.p.o:
	@ if test -f $*.o; then mv $*.o $*.f.o; else :; fi
	$(CC) -c $(PFLAGS) $<
	mv $*.o $*.p.o
	@ if test -f $*.f.o; then mv $*.f.o $*.o; else :; fi

.s.o:
	$(ASPP) -DSYS_$(SYSTEM) -o $*.o $*.s

.s.p.o:
	$(ASPP) -DSYS_$(SYSTEM) $(ASPPPROFFLAGS) -o $*.p.o $*.s

clean::
	rm -f *.o *.a *~

depend: $(COBJS:.o=.c) ${LINKEDFILES}
	-gcc -MM $(FLAGS) *.c > .depend
	gcc -MM $(FLAGS) -DDEBUG *.c | sed -e 's/\.o/.d.o/' >> .depend
	gcc -MM $(FLAGS) -DDEBUG *.c | sed -e 's/\.o/.p.o/' >> .depend

include .depend

=== lex/Makefile ===
#########################################################################
#                                                                       #
#                            Objective Caml                             #
#                                                                       #
#            Xavier Leroy, projet Cristal, INRIA Rocquencourt           #
#                                                                       #
#   Copyright 1999 Institut National de Recherche en Informatique et    #
#   en Automatique.  All rights reserved.  This file is distributed     #
#   under the terms of the Q Public License version 1.0.                #
#                                                                       #
#########################################################################

# $Id: Makefile 9467 2009-12-09 09:52:47Z weis $

# The lexer generator
CAMLC=../boot/ocamlrun ../boot/ocamlc -strict-sequence -nostdlib -I ../boot
CAMLOPT=../boot/ocamlrun ../ocamlopt -nostdlib -I ../stdlib
COMPFLAGS=-warn-error A
CAMLYACC=../boot/ocamlyacc
YACCFLAGS=-v
CAMLLEX=../boot/ocamlrun ../boot/ocamllex
CAMLDEP=../boot/ocamlrun ../tools/ocamldep


OBJS=cset.cmo syntax.cmo parser.cmo lexer.cmo table.cmo lexgen.cmo compact.cmo common.cmo output.cmo outputbis.cmo main.cmo

all: ocamllex
allopt: ocamllex.opt

ocamllex: $(OBJS)
	$(CAMLC) $(LINKFLAGS) -o ocamllex $(OBJS)

ocamllex.opt: $(OBJS:.cmo=.cmx)
	$(CAMLOPT) -o ocamllex.opt $(OBJS:.cmo=.cmx)

clean::
	rm -f ocamllex ocamllex.opt
	rm -f *.cmo *.cmi *.cmx *.o *~

parser.ml parser.mli: parser.mly
	$(CAMLYACC) $(YACCFLAGS) parser.mly

clean::
	rm -f parser.ml parser.mli parser.output

beforedepend:: parser.ml parser.mli

lexer.ml: lexer.mll
	$(CAMLLEX) lexer.mll

clean::
	rm -f lexer.ml

beforedepend:: lexer.ml

.SUFFIXES:
.SUFFIXES: .ml .cmo .mli .cmi .cmx

.ml.cmo:
	$(CAMLC) -c $(COMPFLAGS) $<

.mli.cmi:
	$(CAMLC) -c $(COMPFLAGS) $<

.ml.cmx:
	$(CAMLOPT) -c $(COMPFLAGS) $<

depend: beforedepend
	$(CAMLDEP) *.mli *.ml > .depend

include .depend

=== testsuite/Makefile ===
# $Id: Makefile 10713 2010-10-08 11:53:19Z doligez $

BASEDIR=${PWD}
NO_PRINT=`($(MAKE) empty --no-print-directory > /dev/null 2>&1) && echo '--no-print-directory' || echo ''`

default:
	@echo "Available targets:"
	@echo "  all           launches all tests"
	@echo "  list FILE=f   launches the tests referenced in file f (one path per line)"
	@echo "  one DIR=p     launches the tests located in path p"
	@echo "  lib           builds library modules"
	@echo "  clean         deletes generated files"
	@echo "  report        prints the report for the last execution, if any"

all: lib
	@for dir in tests/*; do \
	  $(MAKE) $(NO_PRINT) exec-one DIR=$$dir; \
	done 2>&1 | tee _log
	@$(MAKE) report

list: lib
	@if [ -z $(FILE) ]; then echo "No value set for variable 'FILE'."; exit 1; fi
	@if [ ! -f $(FILE) ]; then echo "File '$(FILE)' does not exist."; exit 1; fi
	@while read LINE; do \
	  $(MAKE) $(NO_PRINT) exec-one DIR=$$LINE; \
	done < $(FILE) 2>&1 | tee _log
	@$(MAKE) report

one: lib
	@if [ -z $(DIR) ]; then echo "No value set for variable 'DIR'."; exit 1; fi
	@if [ ! -d $(DIR) ]; then echo "Directory '$(DIR)' does not exist."; exit 1; fi
	@$(MAKE) $(NO_PRINT) exec-one DIR=$(DIR)

exec-one:
	@echo "Running tests from '$$DIR' ..."
	@(cd $(DIR) && $(MAKE) TERM=dumb BASEDIR=$(BASEDIR) && cd ../..)

lib: FORCE
	@(cd lib && $(MAKE) -s BASEDIR=$(BASEDIR) && cd ..)

clean: FORCE
	@(cd lib && $(MAKE) BASEDIR=$(BASEDIR) clean && cd ..)
	@for file in tests/*; do \
	  if [ -d $$file ]; then \
	    (cd $$file && $(MAKE) BASEDIR=$(BASEDIR) clean && cd ../..); \
	  fi \
	done
	@for file in interactive/*; do \
	  if [ -d $$file ]; then \
	    (cd $$file && $(MAKE) BASEDIR=$(BASEDIR) clean && cd ../..); \
	  fi \
	done

report: FORCE
	@if [ ! -f _log ]; then echo "No '_log' file."; exit 1; fi
	@echo ''
	@echo 'Summary:'
	@echo '  ' `grep 'passed$$' _log | wc -l` 'test(s) passed'
	@echo '  ' `grep 'failed$$' _log | wc -l` 'test(s) failed'
	@echo '  ' `grep '^Error' _log | wc -l` 'compilation error(s)'
	@echo '  ' `grep '^Warning' _log | wc -l` 'compilation warning(s)'

empty: FORCE

FORCE:

=== win32caml/Makefile ===
#########################################################################
#                                                                       #
#                            Objective Caml                             #
#                                                                       #
#            Xavier Leroy, projet Cristal, INRIA Rocquencourt           #
#                                                                       #
#   Copyright 2001 Institut National de Recherche en Informatique et    #
#   en Automatique.  All rights reserved.  This file is distributed     #
#   under the terms of the GNU Library General Public License, with     #
#   the special exception on linking described in file ../LICENSE.      #
#                                                                       #
#########################################################################

# $Id: Makefile 8521 2007-11-15 13:21:15Z frisch $

include ../config/Makefile

CC=$(BYTECC)
CFLAGS=$(BYTECCCOMPOPTS)

OBJS=startocaml.$(O) ocamlres.$(O) ocaml.$(O) menu.$(O) \
  history.$(O) editbuffer.$(O)

LIBS=$(call SYSLIB,kernel32) $(call SYSLIB,advapi32) $(call SYSLIB,gdi32) \
     $(call SYSLIB,user32) $(call SYSLIB,comdlg32) $(call SYSLIB,comctl32)

all: ocamlwin.exe

ocamlwin.exe: $(OBJS)
	$(MKEXE) -o ocamlwin.exe $(OBJS) $(LIBS) $(EXTRALIBS) -subsystem windows

ocamlres.$(O): ocaml.rc ocaml.ico
ifeq ($(TOOLCHAIN),msvc)
	rc ocaml.rc
ifeq ($(ARCH),amd64)
	cvtres /nologo /machine:amd64 /out:$@ ocaml.res
else
	cvtres /nologo /machine:ix86 /out:$@ ocaml.res
endif
	rm -f ocaml.res
endif
ifeq ($(TOOLCHAIN),mingw)
	windres -i ocaml.rc -o $@
endif

$(OBJS): inria.h inriares.h history.h editbuffer.h

clean:
	rm -f ocamlwin.exe *.$(O) *.pdb ocamlwin.ilk

install:
	cp ocamlwin.exe $(PREFIX)/OCamlWin.exe

.SUFFIXES: .c .$(O)

.c.$(O):
	$(CC) $(CFLAGS) -c $*.c

=== ocamlbuild/manual/Makefile ===
# Makefile

all: manual.pdf manual.html

%.pdf: %.tex
	pdflatex $<
	pdflatex $<

%.html: %.tex manual.hva
	hevea -fix -O manual.hva $<

.PHONY: clean

clean:
	rm -f *.pdf *.log *.aux *.ps *.dvi manual.h{tml,aux,toc}

=== otherlibs/bigarray/Makefile ===
#########################################################################
#                                                                       #
#                            Objective Caml                             #
#                                                                       #
#            Xavier Leroy, projet Cristal, INRIA Rocquencourt           #
#                                                                       #
#   Copyright 1999 Institut National de Recherche en Informatique et    #
#   en Automatique.  All rights reserved.  This file is distributed     #
#   under the terms of the GNU Library General Public License, with     #
#   the special exception on linking described in file ../../LICENSE.   #
#                                                                       #
#########################################################################

# $Id: Makefile 8748 2008-01-04 09:52:27Z xleroy $

LIBNAME=bigarray
EXTRACFLAGS=-I../unix -DIN_OCAML_BIGARRAY -DCAML_NAME_SPACE
EXTRACAMLFLAGS=-I ../unix
COBJS=bigarray_stubs.$(O) mmap_unix.$(O)
CAMLOBJS=bigarray.cmo
HEADERS=bigarray.h

include ../Makefile

depend:
	gcc -MM $(CFLAGS) *.c > .depend
	../../boot/ocamlrun ../../tools/ocamldep *.mli *.ml >> .depend

include .depend

=== otherlibs/threads/Makefile ===
#########################################################################
#                                                                       #
#                            Objective Caml                             #
#                                                                       #
#            Xavier Leroy, projet Cristal, INRIA Rocquencourt           #
#                                                                       #
#   Copyright 1999 Institut National de Recherche en Informatique et    #
#   en Automatique.  All rights reserved.  This file is distributed     #
#   under the terms of the GNU Library General Public License, with     #
#   the special exception on linking described in file ../../LICENSE.   #
#                                                                       #
#########################################################################

# $Id: Makefile 9153 2008-12-03 18:09:09Z doligez $

include ../../config/Makefile

CC=$(BYTECC)
CFLAGS=-I../../byterun -O $(BYTECCCOMPOPTS) $(SHAREDCCCOMPOPTS) -g
CAMLC=../../ocamlcomp.sh -I ../unix
MKLIB=../../boot/ocamlrun ../../tools/ocamlmklib
COMPFLAGS=-warn-error A

C_OBJS=scheduler.o

CAML_OBJS=thread.cmo mutex.cmo condition.cmo event.cmo threadUnix.cmo

LIB=../../stdlib

LIB_OBJS=pervasives.cmo \
  $(LIB)/array.cmo $(LIB)/list.cmo $(LIB)/char.cmo $(LIB)/string.cmo \
  $(LIB)/sys.cmo $(LIB)/hashtbl.cmo $(LIB)/sort.cmo \
  marshal.cmo $(LIB)/obj.cmo $(LIB)/int32.cmo $(LIB)/int64.cmo \
  $(LIB)/nativeint.cmo \
  $(LIB)/lexing.cmo $(LIB)/parsing.cmo \
  $(LIB)/set.cmo $(LIB)/map.cmo $(LIB)/stack.cmo $(LIB)/queue.cmo \
  $(LIB)/camlinternalLazy.cmo $(LIB)/lazy.cmo \
  $(LIB)/stream.cmo $(LIB)/buffer.cmo \
  $(LIB)/printf.cmo $(LIB)/format.cmo \
  $(LIB)/scanf.cmo $(LIB)/arg.cmo \
  $(LIB)/printexc.cmo $(LIB)/gc.cmo $(LIB)/digest.cmo $(LIB)/random.cmo \
  $(LIB)/camlinternalOO.cmo $(LIB)/oo.cmo $(LIB)/camlinternalMod.cmo \
  $(LIB)/genlex.cmo $(LIB)/callback.cmo $(LIB)/weak.cmo \
  $(LIB)/filename.cmo $(LIB)/complex.cmo \
  $(LIB)/arrayLabels.cmo $(LIB)/listLabels.cmo $(LIB)/stringLabels.cmo \
  $(LIB)/stdLabels.cmo $(LIB)/moreLabels.cmo

UNIXLIB=../unix

UNIXLIB_OBJS=unix.cmo $(UNIXLIB)/unixLabels.cmo

all: libvmthreads.a threads.cma stdlib.cma unix.cma

allopt:

libvmthreads.a: $(C_OBJS)
	$(MKLIB) -o threads -oc vmthreads $(C_OBJS)

threads.cma: $(CAML_OBJS)
	$(MKLIB) -ocamlc '$(CAMLC)' -o threads -oc vmthreads $(CAML_OBJS)

stdlib.cma: $(LIB_OBJS)
	$(CAMLC) -a -o stdlib.cma $(LIB_OBJS)

unix.cma: $(UNIXLIB_OBJS)
	$(MKLIB) -ocamlc '$(CAMLC)' -o unix -linkall $(UNIXLIB_OBJS)

pervasives.cmo: pervasives.mli pervasives.cmi pervasives.ml
	$(CAMLC) ${COMPFLAGS} -nopervasives -c pervasives.ml

pervasives.mli: $(LIB)/pervasives.mli
	ln -s $(LIB)/pervasives.mli pervasives.mli

pervasives.cmi: $(LIB)/pervasives.cmi
	ln -s $(LIB)/pervasives.cmi pervasives.cmi

marshal.cmo: marshal.mli marshal.cmi marshal.ml
	$(CAMLC) ${COMPFLAGS} -c marshal.ml

marshal.mli: $(LIB)/marshal.mli
	ln -s $(LIB)/marshal.mli marshal.mli

marshal.cmi: $(LIB)/marshal.cmi
	ln -s $(LIB)/marshal.cmi marshal.cmi

unix.mli: $(UNIXLIB)/unix.mli
	ln -s -f $(UNIXLIB)/unix.mli unix.mli

unix.cmi: $(UNIXLIB)/unix.cmi
	ln -s -f $(UNIXLIB)/unix.cmi unix.cmi

unix.cmo: unix.mli unix.cmi $(UNIXLIB)/unixLabels.cmo
	$(CAMLC) ${COMPFLAGS} -c unix.ml

partialclean:
	rm -f *.cm*

clean: partialclean
	rm -f libvmthreads.a dllvmthreads.so *.o
	rm -f pervasives.mli marshal.mli unix.mli

install:
	if test -f dllvmthreads.so; then cp dllvmthreads.so $(STUBLIBDIR)/.; fi
	mkdir -p $(LIBDIR)/vmthreads
	cp libvmthreads.a $(LIBDIR)/vmthreads/libvmthreads.a
	cd $(LIBDIR)/vmthreads; $(RANLIB) libvmthreads.a
	cp thread.cmi mutex.cmi condition.cmi event.cmi threadUnix.cmi threads.cma stdlib.cma unix.cma $(LIBDIR)/vmthreads
	cp thread.mli mutex.mli condition.mli event.mli threadUnix.mli $(LIBDIR)/vmthreads

installopt:

.SUFFIXES: .ml .mli .cmo .cmi .cmx

.mli.cmi:
	$(CAMLC) -c $(COMPFLAGS) $<

.ml.cmo:
	$(CAMLC) -c $(COMPFLAGS) $<

.ml.cmx:
	$(CAMLOPT) -c $(COMPFLAGS) $<

depend:
	gcc -MM $(CFLAGS) *.c > .depend
	../../boot/ocamlrun ../../tools/ocamldep *.mli *.ml >> .depend

include .depend

=== camlp4/unmaintained/olabl/Makefile ===
#########################################################################
#                                                                       #
#                            Objective Caml                             #
#                                                                       #
#                                Camlp4                                 #
#                                                                       #
#   Copyright 2004 Institut National de Recherche en Informatique et    #
#   en Automatique.  All rights reserved.  This file is distributed     #
#   under the terms of the Q Public License version 1.0.                #
#                                                                       #
#########################################################################
#
# Makefile for pa_lefteval
# M.Mauny
#

include ../../config/Makefile.cnf

OCAMLTOP=../../..
CAMLP4=../../camlp4/camlp4$(EXE)

OCAMLC=$(OCAMLTOP)/ocamlc$(EXE)
OCAMLOPT=$(OCAMLTOP)/ocamlopt$(EXE)

P4INCLUDES= -nolib -I ../../meta -I ../../lib -I ../../etc
OCAMLINCLUDES= -nostdlib -I $(OCAMLTOP)/stdlib -I ../../lib -I ../../camlp4
OCAMLCFLAGS=-warn-error A $(OCAMLINCLUDES)

SRC=pa_olabl.ml
OBJS=$(SRC:.ml=.cmo)
OBJSX=$(SRC:.ml=.cmx)

all: $(OBJS)

opt: $(OBJSX)

depend:
	cp .depend .depend.bak
	> .depend
	for file in $(SRC); do \
	  $(CAMLP4) $(P4INCLUDES) `awk 'NR == 1 { ORS=" "; for (i=2; i < NF; i++) print $$i; } ' $$file` pr_depend.cmo $$i | \
	  sed -e 's| \.\./\.\./\.\.| $$(OCAMLTOP)|g' >> .depend; \
	done

clean:
	rm -f *.cm* *.$(O) *.bak .*.bak


.SUFFIXES: .cmx .cmo .cmi .ml .mli

.mli.cmi:
	$(OCAMLC) $(OCAMLCFLAGS) -c $<


.ml.cmo:
	$(OCAMLC) $(OCAMLCFLAGS) -pp "$(CAMLP4) $(P4INCLUDES) `awk 'NR == 1 { ORS=" "; for (i=2; i < NF; i++) print $$i; } ' $<`" -c $<

.ml.cmx:
	$(OCAMLOPT) $(OCAMLCFLAGS) -pp "$(CAMLP4) $(P4INCLUDES) `awk 'NR == 1 { ORS=" "; for (i=2; i < NF; i++) print $$i; } ' $<`" -c $<

include .depend

=== camlp4/unmaintained/scheme/Makefile ===
#########################################################################
#                                                                       #
#                            Objective Caml                             #
#                                                                       #
#                                Camlp4                                 #
#                                                                       #
#   Copyright 2004 Institut National de Recherche en Informatique et    #
#   en Automatique.  All rights reserved.  This file is distributed     #
#   under the terms of the Q Public License version 1.0.                #
#                                                                       #
#########################################################################
#
# Makefile for pa_lefteval
# M.Mauny
#

include ../../config/Makefile.cnf

OCAMLTOP=../../..
CAMLP4=../../camlp4/camlp4$(EXE)

OCAMLC=$(OCAMLTOP)/ocamlc$(EXE)
OCAMLOPT=$(OCAMLTOP)/ocamlopt$(EXE)

P4INCLUDES= -nolib -I ../../meta -I ../../etc
OCAMLINCLUDES= -nostdlib -I $(OCAMLTOP)/stdlib -I ../../camlp4 -I ../../lib -I ../../etc
OCAMLCFLAGS=-warn-error A $(OCAMLINCLUDES)

SCHSRC=pa_scheme.sc
SRC=pa_scheme.ml  pr_scheme.ml  pr_schp_main.ml
OBJS=$(SRC:.ml=.cmo)
OBJSX=$(OCAMLSRC:.ml=.cmx)

all: $(OBJS) pr_schemep.cmo camlp4sch$(EXE)

opt: all

bootstrap: camlp4sch$(EXE) save
	./camlp4sch$(EXE) ../../etc/q_phony.cmo ../../meta/pa_extend.cmo ../../etc/pr_r.cmo ../../etc/pr_extend.cmo ../../etc/pr_rp.cmo -impl pa_scheme.sc \
	  | sed -e 's/^;; \(.*\)$$/(* \1 *)/' -e 's/^; \(.*\)$$/(* \1 *)/' \
		-e 's/$$Id.*\$$/File generated by pretty print; do not edit!/' > pa_scheme.ml
	@if cmp -s pa_scheme.ml SAVED/pa_scheme.ml; then \
		echo 'pa_scheme.ml and SAVED/pa_scheme.ml are identical' ; \
	 else \
		echo '**** Note: pa_scheme.ml differs from SAVED/pa_scheme.ml'; \
	 fi

save:
	test -d SAVED || mkdir SAVED
	mkdir SAVED.$$$$ && mv SAVED pa_scheme.ml SAVED.$$$$ && mv SAVED.$$$$ SAVED

restore:
	mv SAVED SAVED.$$$$ && mv SAVED.$$$$/* . && rmdir SAVED.$$$$

depend:
	cp .depend .depend.bak
	> .depend
	for file in $(SRC); do \
	  $(CAMLP4) $(P4INCLUDES) `awk 'NR == 1 { ORS=" "; for (i=2; i < NF; i++) print $$i; } ' $$file` pr_depend.cmo $$i | \
	  sed -e 's| \.\./\.\./\.\.| $$(OCAMLTOP)|g' >> .depend; \
	done

clean:
	rm -f camlp4sch$(EXE) *.cm* *.$(O) *.bak .*.bak

camlp4sch: pa_scheme.cmo
	rm -f camlp4sch
	DIR=`pwd` && cd ../../camlp4 && $(MAKE) CAMLP4=$$DIR/camlp4sch CAMLP4M="-I $$DIR pa_scheme.cmo ../meta/pr_dump.cmo"

pr_schemep.cmo: pr_schp_main.cmo
	$(OCAMLC) ../../etc/parserify.cmo pr_schp_main.cmo -a -o $@

.SUFFIXES: .cmx .cmo .cmi .ml .mli

.mli.cmi:
	$(OCAMLC) $(OCAMLCFLAGS) -c $<


.ml.cmo:
	$(OCAMLC) $(OCAMLCFLAGS) -pp "$(CAMLP4) $(P4INCLUDES) `awk 'NR == 1 { ORS=" "; for (i=2; i < NF; i++) print $$i; } ' $<` -loc loc" -c $< 

.ml.cmx:
	$(OCAMLOPT) $(OCAMLCFLAGS) -pp "$(CAMLP4) $(P4INCLUDES)  `awk 'NR == 1 { ORS=" "; for (i=2; i < NF; i++) print $$i; } ' $<` -loc loc" -c $<

include .depend

=== otherlibs/labltk/jpf/Makefile ===
include ../support/Makefile.common

COMPFLAGS=-I ../labltk -I ../support -I $(OTHERS)/win32unix -I $(OTHERS)/unix -I $(OTHERS)/str

OBJS= fileselect.cmo balloon.cmo shell.cmo jpf_font.cmo

OBJSX = $(OBJS:.cmo=.cmx)

all: jpflib.cma

opt: jpflib.cmxa

test: balloontest

testopt: balloontest.opt

jpflib.cma: $(OBJS)
	$(CAMLLIBR) -o jpflib.cma $(OBJS)

jpflib.cmxa: $(OBJSX)
	$(CAMLOPTLIBR) -o jpflib.cmxa $(OBJSX)

install:
	cp $(OBJS:.cmo=.cmi) $(OBJS:.cmo=.mli) jpflib.cma $(INSTALLDIR)

installopt:
	cp jpflib.cmxa jpflib.$(A) $(OBJS:.cmo=.cmx) $(INSTALLDIR)

clean:
	rm -f *.cm* *.$(O) *.$(A) *~ *test

$(OBJS) $(OBJS:.cmo=.cmi): ../lib/$(LIBNAME).cma

$(OBJSX): ../lib/$(LIBNAME).cmxa

### Tests

balloontest: balloontest.cmo
	$(CAMLC) -o balloontest -I ../support -I ../lib \
	        -custom $(LIBNAME).cma jpflib.cma balloontest.cmo

balloontest.opt: balloontest.cmx
	$(CAMLOPT) -o balloontest.opt -I ../support -I ../lib \
	        $(LIBNAME).cmxa jpflib.cmxa balloontest.cmx

balloontest.cmo : balloon.cmo jpflib.cma

balloontest.cmx : balloon.cmx jpflib.cmxa

.SUFFIXES :
.SUFFIXES : .mli .ml .cmi .cmx .cmo

.mli.cmi:
	$(CAMLCOMP) $(COMPFLAGS) $<

.ml.cmo:
	$(CAMLCOMP) $(COMPFLAGS) $<

.ml.cmx:
	$(CAMLOPT) -c $(COMPFLAGS) $<

depend:
	mv Makefile Makefile.bak
	(sed -n -e '1,/^### DO NOT DELETE THIS LINE/p' Makefile.bak; \
	 $(CAMLDEP) *.mli *.ml) > Makefile


### EVERYTHING THAT GOES BEYOND THIS COMMENT IS GENERATED
### DO NOT DELETE THIS LINE
balloon.cmo: balloon.cmi
balloon.cmx: balloon.cmi
fileselect.cmo: fileselect.cmi
fileselect.cmx: fileselect.cmi
jpf_font.cmo: shell.cmi jpf_font.cmi
jpf_font.cmx: shell.cmx jpf_font.cmi
shell.cmo: shell.cmi
shell.cmx: shell.cmi

=== otherlibs/labltk/lib/Makefile ===
include ../support/Makefile.common

all: $(LIBNAME).cma $(LIBNAME)top$(EXE) $(LIBNAME)

opt: $(LIBNAME).cmxa

clean:
	rm -f $(LIBNAME)top$(EXE) $(LIBNAME) *.cm* *.$(A)

superclean:
	- if test -f tk.cmo; then \
	  echo We have changes... Now lib directory has no .cmo files; \
	  rm -f *.cm* *.$(O); \
	fi

include ../labltk/modules
LABLTKOBJS=tk.cmo $(WIDGETOBJS)

include ../camltk/modules
CAMLTKOBJS=cTk.cmo $(CWIDGETOBJS) labltk.cmo camltk.cmo

SUPPORT=../support/support.cmo ../support/rawwidget.cmo \
	../support/widget.cmo ../support/protocol.cmo \
	../support/textvariable.cmo ../support/timer.cmo \
	../support/fileevent.cmo ../support/camltkwrap.cmo

TKOBJS=$(SUPPORT) $(LABLTKOBJS) $(CAMLTKOBJS)

TOPDEPS = $(TOPDIR)/toplevel/toplevellib.cma $(TOPDIR)/toplevel/topmain.cmo

$(LIBNAME).cma: $(SUPPORT) ../Widgets.src
	$(MAKE) superclean
	cd ../labltk; $(MAKE)
	cd ../camltk; $(MAKE)
	$(MKLIB) -ocamlc '$(CAMLCB)' -o $(LIBNAME) \
	  -I ../labltk -I ../camltk $(TKOBJS) \
	  -ccopt "\"$(TK_LINK)\""

$(LIBNAME).cmxa: $(SUPPORT:.cmo=.cmx) ../Widgets.src
	$(MAKE) superclean
	cd ../labltk; $(MAKE) opt
	cd ../camltk; $(MAKE) opt
	$(MKLIB) -ocamlopt '$(CAMLOPTB)' -o $(LIBNAME) -oc $(LIBNAME) \
	  -I ../labltk -I ../camltk $(TKOBJS:.cmo=.cmx) \
	  -ccopt "\"$(TK_LINK)\""

$(LIBNAME)top$(EXE) : $(TOPDEPS) $(LIBNAME).cma ../support/lib$(LIBNAME).$(A)
	$(CAMLC) -verbose -linkall -o $(LIBNAME)top$(EXE) -I ../support \
	       -I $(TOPDIR)/toplevel toplevellib.cma \
	       -I $(OTHERS)/unix -I $(OTHERS)/win32unix unix.cma \
	       -I ../labltk -I ../camltk $(LIBNAME).cma \
	       -I $(OTHERS)/str str.cma \
	       topstart.cmo

$(LIBNAME): Makefile $(TOPDIR)/config/Makefile
	@echo Generate $@
	@echo "#!/bin/sh" > $@
	@echo 'exec $(INSTALLDIR)/$(LIBNAME)top$(EXE) -I $(INSTALLDIR) $$*' >> $@

install-script: $(LIBNAME)
	cp $(LIBNAME) $(BINDIR)
	chmod 755 $(BINDIR)/$(LIBNAME)

install-batch:
	cp labltk.bat $(BINDIR)

install:
	if test -d $(INSTALLDIR); then : ; else mkdir $(INSTALLDIR); fi
	cp $(LIBNAME).cma $(LIBNAME)top$(EXE) $(INSTALLDIR)
	chmod 644 $(INSTALLDIR)/$(LIBNAME).cma
	chmod 755 $(INSTALLDIR)/$(LIBNAME)top$(EXE)
	@if test -d $(BINDIR); then : ; else mkdir $(BINDIR); fi
	@case x$(TOOLCHAIN) in \
	  xmingw|xmsvc) $(MAKE) install-batch ;; \
	  *) 		$(MAKE) install-script ;; \
	esac

installopt:
	@if test -d $(INSTALLDIR); then : ; else mkdir $(INSTALLDIR); fi
	cp $(LIBNAME).cmxa $(LIBNAME).$(A) $(INSTALLDIR)
	cd $(INSTALLDIR); $(RANLIB) $(LIBNAME).$(A)
	chmod 644 $(INSTALLDIR)/$(LIBNAME).cmxa
	chmod 644 $(INSTALLDIR)/$(LIBNAME).$(A)

=== testsuite/interactive/lib-graph/Makefile ===
#MODULES=
MAIN_MODULE=graph_example
#ADD_COMPFLAGS=
LIBRARIES=graphics

include ../../makefiles/Makefile.one
include ../../makefiles/Makefile.common

=== debian/changelog ===
ocaml (3.12.1-4+deb7u1) wheezy-security; urgency=high

  * Non-maintainer upload by the Wheezy LTS Team. 
  * CVE-2015-8869
    OCaml versions 4.02.3 and earlier have a runtime bug that, 
    on 64-bit platforms, causes sizes arguments to an internal 
    memmove call to be sign-extended from 32 to 64-bits before 
    being passed to the memmove function.
    This leads arguments between 2GiB and 4GiB to be interpreted 
    as larger than they are (specifically, a bit below 2^64), 
    causing a buffer overflow.
    Arguments between 4GiB and 6GiB are interpreted as 4GiB smaller 
    than they should be, causing a possible information leak.
 
 -- Thorsten Alteholz <debian@alteholz.de>  Wed, 11 May 2016 19:03:02 +0200

ocaml (3.12.1-4) unstable; urgency=low

  * Change the Debian-specific behaviour of -custom (Closes: #678577)

 -- Stéphane Glondu <glondu@debian.org>  Tue, 26 Jun 2012 21:39:18 +0200

ocaml (3.12.1-3) unstable; urgency=low

  [ Hendrik Tews ]
  * Fixes in startup and install files of ocaml-mode:
    - symlink *el files into elc dir (Closes: #452340)
    - use debian-pkg-add-load-path-item in emacsen-startup and emacsen-install
      (Closes: 671559)
    - compile el files with site-file enabled
    - use debian-emacs-flavor in emacsen-startup (see #662163)

  [ Stéphane Glondu ]
  * Fix debian/watch so that refman is not reported as a new version
  * Add some explicit dependencies to avoid spurious Lintian warnings
    about broken symlinks
  * Remove duplicate upstream changelog

 -- Stéphane Glondu <glondu@debian.org>  Mon, 14 May 2012 07:52:40 +0200

ocaml (3.12.1-2) unstable; urgency=low

  * Fix compilation on kfreebsd-any: do not add -R$dir in X11 link options

 -- Stéphane Glondu <glondu@debian.org>  Tue, 01 Nov 2011 16:11:01 +0100

ocaml (3.12.1-1) unstable; urgency=low

  [ Stéphane Glondu ]
  * New upstream release (Closes: #634621)
  * ocamlopt/arm: add .type directive for code symbols (LP: #810402)

  [ Mehdi Dogguy ]
  * Make objinfo show force_link and ccobjs/ccopts when needed

  [ Jonathan Nieder ]
  * debian/control: add Breaks against versions of dh-ocaml that relied on
    the ocaml{dumpapprox,plugininfo,byteinfo} tools (Closes: #642935)

  [ Stefano Zacchiroli ]
  * remove myself from Uploaders

  [ Samuel Thibault ]
  * Add support for ENOTSUP (Closes: #646372)

 -- Stéphane Glondu <glondu@debian.org>  Tue, 01 Nov 2011 13:53:49 +0100

=== debian/control ===
Source: ocaml
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Samuel Mimram <smimram@debian.org>,
 Sylvain Le Gall <gildor@debian.org>,
 Ralf Treinen <treinen@debian.org>,
 Stéphane Glondu <glondu@debian.org>,
 Mehdi Dogguy <mehdi@debian.org>
Build-Depends:
 debhelper (>= 8),
 pkg-config,
 autotools-dev,
 binutils-dev,
 tcl8.5-dev,
 tk8.5-dev,
 libncurses5-dev,
 libgdbm-dev,
 bzip2,
 dh-ocaml (>= 1.0.0~)
Standards-Version: 3.9.2
Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/ocaml.git
Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/ocaml.git
Homepage: http://caml.inria.fr/

Package: ocaml-nox
Architecture: any
Depends:
 ocaml-base-nox,
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends},
 libncurses5-dev,
 ocaml-interp (= ${binary:Version}),
 gcc,
 binutils
Provides:
 ${ocaml:Provides},
 ${F:BestProvides},
 libnums-ocaml-dev
Suggests:
 ocaml-doc,
 libgdbm-dev,
 tuareg-mode | ocaml-mode
Recommends:
 camlp4,
 file
Replaces: ocaml-interp (<< 3.11.1-3)
Breaks:
 dh-ocaml (<< 1.0.0),
 ocaml-interp (<< 3.11.1-3),
 camlp4 (<< 3.10.0),
 camlidl (<< 1.04)
Description: ML implementation with a class-based object system (no X)
 Objective Caml (OCaml) is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 OCaml comprises two compilers. One generates bytecode
 which is then interpreted by a C program. This compiler runs quickly,
 generates compact code with moderate memory requirements, and is
 portable to essentially any 32 or 64 bit Unix platform. Performance of
 generated programs is quite good for a bytecoded implementation:
 almost twice as fast as Caml Light 0.7. This compiler can be used
 either as a standalone, batch-oriented compiler that produces
 standalone programs, or as an interactive, toplevel-based system.
 .
 The other compiler generates high-performance native code for a number
 of processors. Compilation takes longer and generates bigger code, but
 the generated programs deliver excellent performance, while retaining
 the moderate memory requirements of the bytecode compiler. It is not
 available on all arches though.
 .
 This package contains everything needed to develop OCaml applications
 that do not require the graphics library.

Package: camlp4
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends}
Provides:
 ${ocaml:Provides}
Description: Pre Processor Pretty Printer for OCaml
 Objective Caml (OCaml) is an implementation of the ML language,
 based on the Caml Light dialect extended with a complete
 class-based object system and a powerful module system in the
 style of Standard ML.
 .
 CamlP4 is a Pre-Processor-Pretty-Printer for Objective Caml. It
 offers tools for syntax (Stream Parsers and Grammars) and the
 ability to modify the concrete syntax of the language
 (Quotations, Syntax Extensions).
 .
 This package contains the basic CamlP4 executables and libraries
 for pre-processing and pretty-printing OCaml sources both
 interactively and in a batch fashion.

Package: camlp4-extra
Architecture: any
Depends:
 camlp4,
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends},
 ocaml-nox-${F:OCamlABI},
 camlp4-${F:OCamlABI}
Description: Pre Processor Pretty Printer for OCaml - extras
 Objective Caml (OCaml) is an implementation of the ML language,
 based on the Caml Light dialect extended with a complete
 class-based object system and a powerful module system in the
 style of Standard ML.
 .
 CamlP4 is a Pre-Processor-Pretty-Printer for Objective Caml. It
 offers tools for syntax (Stream Parsers and Grammars) and the
 ability to modify the concrete syntax of the language
 (Quotations, Syntax Extensions).
 .
 This package contains pre-linked executables and libraries for
 pre-processing and pretty-printing OCaml sources out of the box
 for various common needs.

Package: ocaml
Architecture: any
Depends:
 ocaml-base-nox,
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends},
 libx11-dev
Provides:
 ${ocaml:Provides}
Suggests:
 tcl8.5-dev,
 tk8.5-dev
Replaces: ocaml-nox (<< 3.11.0-2)
Description: ML language implementation with a class-based object system
 Objective Caml (OCaml) is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 OCaml comprises two compilers. One generates bytecode
 which is then interpreted by a C program. This compiler runs quickly,
 generates compact code with moderate memory requirements, and is
 portable to essentially any 32 or 64 bit Unix platform. Performance of
 generated programs is quite good for a bytecoded implementation:
 almost twice as fast as Caml Light 0.7. This compiler can be used
 either as a standalone, batch-oriented compiler that produces
 standalone programs, or as an interactive, toplevel-based system.
 .
 The other compiler generates high-performance native code for a number
 of processors. Compilation takes longer and generates bigger code, but
 the generated programs deliver excellent performance, while retaining
 the moderate memory requirements of the bytecode compiler. It is not
 available on all arches though.
 .
 This package contains everything needed to develop OCaml applications,
 including the graphics libraries.

Package: ocaml-base-nox
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends}
Provides:
 ${ocaml:Provides}
Replaces: ocaml-interp (<< 3.11.1-3)
Breaks: ocaml-interp (<< 3.11.1-3)
Description: Runtime system for OCaml bytecode executables (no X)
 Objective Caml (OCaml) is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 This package contains only the runtime system needed to run bytecode
 executables that do not use the graphics library. The 'ocaml' package
 contains the full development suite of Objective Caml.

Package: ocaml-base
Architecture: any
Depends:
 ocaml-base-nox,
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends}
Provides:
 ${ocaml:Provides}
Description: Runtime system for OCaml bytecode executables
 Objective Caml (OCaml) is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 This package contains only the runtime system needed to run bytecode
 executables. The 'ocaml' package contains the full development suite of
 Objective Caml.  You may wish to install the 'ocaml-base-nox' package if
 you do not require any graphical capabilities for your runtime.

Package: ocaml-native-compilers
Architecture: amd64 armel hurd-i386 i386 kfreebsd-i386 kfreebsd-amd64 lpia powerpc sparc
Depends:
 ocaml-nox (= ${binary:Version}),
 gcc, binutils,
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ocaml-best-compilers
Replaces: ocaml-nox (<= 3.09.2-3)
Description: Native code compilers of the OCaml suite (the .opt ones)
 Objective Caml (OCaml) is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 This package contains the native code version of the compilers and lexer
 (ocamlc.opt, ocamllex.opt, ocamlopt.opt, camlp4o.opt and camlp4r.opt).
 The normal version of these programs are found in the 'ocaml' package.
 For big source codes, these packages can be two to three times faster, but
 for most normal sized sources, the difference won't be noticeable.

Package: ocaml-source
Architecture: all
Depends: ${misc:Depends}
Provides: ocaml-source-${F:OCamlABI}
Description: Sources for Objective Caml
 Objective Caml (OCaml) is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 This package contains the sources needed to build some packages which build
 depend on the OCaml source. Notice that if you want to rebuild OCaml, these
 will not work, consider using the source package instead.

Package: ocaml-interp
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides:
 ocaml-interp-${F:OCamlABI}
Recommends: ledit | readline-editor
Description: OCaml interactive interpreter and standard libraries
 Objective Caml (OCaml) is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 This package contains the files required to run an OCaml shell from the
 command line.

Package: ocaml-compiler-libs
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends},
 ocaml-nox-${F:OCamlABI}
Provides:
 ocaml-compiler-libs-${F:OCamlABI}
Description: OCaml interpreter and standard libraries
 Objective (OCaml) is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 This package contains several modules used internally by the OCaml
 compilers.  They are not needed for normal OCaml development, but may
 be helpful in the development of certain applications.

Package: ocaml-mode
Architecture: all
Depends:
 emacs23 | emacsen,
 ${shlibs:Depends},
 ${misc:Depends}
Suggests: ocaml
Description: major mode for editing Objective Caml in Emacs
 Objective (OCaml) is an implementation of the ML language, based on
 the Caml Light dialect extended with a complete class-based object system
 and a powerful module system in the style of Standard ML.
 .
 This package provides support for editing both Objective Caml and
 Caml Light programs with Emacs and XEmacs.
 .
 Caml-mode supports:
  - indentation
  - compilation and error retrieving
  - interaction with the toplevel
  - font-lock
  - imenu

=== debian/rules ===
#!/usr/bin/make -f

PACKAGE := ocaml
ALL_PACKAGES := $(shell dh_listpackages)
OCAMLMAJOR := 3.12
OCAMLMINOR := 1

# Build cache (for Debian debugging)
BUILDCACHE := $(wildcard ../ocaml.cache)

# These are defined here to avoid definition of them in ocamlvars.mk
OCAML_ABI := $(OCAMLMAJOR).$(OCAMLMINOR)
OCAML_STDLIB_DIR := /usr/lib/ocaml
OCAML_NATIVE_ARCHS := $(shell cat debian/native-archs)
OCAML_NATDYNLINK_ARCHS := $(shell cat debian/natdynlink-archs)
DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
OCAML_OPT_ARCH := $(findstring $(DEB_BUILD_ARCH),$(OCAML_NATIVE_ARCHS))
OCAML_HAVE_OCAMLOPT := $(if $(OCAML_OPT_ARCH),yes,no)
OCAML_OCAMLDOC_DESTDIR_HTML =

ifneq (,$(findstring $(DEB_BUILD_ARCH),$(OCAML_NATDYNLINK_ARCHS)))
  OCAML_NATDYNLINK := yes
else
  OCAML_NATDYNLINK := no
endif

# dh_ocamlinit cannot be used for ocaml itself
include debian/ocamlinit.mk

MD5SUMSDIR = /var/lib/ocaml/md5sums
INSTDIR = $(CURDIR)/debian/tmp/usr
DISTDIR = $(PACKAGE)-$(OCAML_ABI)
SRCTARBALL = $(PACKAGE)-source-$(OCAML_ABI).tar.bz2

ifneq (,$(findstring ocaml-source,$(ALL_PACKAGES)))
  TARBALL_TARGET = debian/$(SRCTARBALL)
else
  TARBALL_TARGET =
endif

# Environment variable for dh_ocaml
export OCAMLOBJINFO = OCAMLLIB=tools boot/ocamlrun tools/objinfo

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DH_OPTIONS
ifeq ($(OCAML_OPT_ARCH),)
  DH_OPTIONS += -Nocaml-native-compilers
endif

# This has to be exported to make gen_modules work
export OCAML_OPT_ARCH
export OCAML_STDLIB_DIR

CONFIGURE_OPTS := \
  --with-pthread -prefix /usr \
  -libdir $(OCAML_STDLIB_DIR) \
  -x11lib "$(shell pkg-config --variable=libdir x11)" \
  -mandir /usr/share/man \
  -tkdefs "-I/usr/include/tcl8.5" \
  -tklibs "-L/usr/lib -ltk8.5 -ltcl8.5"

CONFIGURE_SED := \
  -e "/LIBBFD_LINK/s%-lbfd%-Wl,-Bstatic -lbfd -Wl,-Bdynamic%" \
  -e "s%MANDIR=.*$$%MANDIR=\$$(PREFIX)/share/man%g" \
  -e "s%LIBDIR=.*$$%LIBDIR=\$$(PREFIX)/lib/ocaml%g" \
  -e "s%STUBLIBDIR=.*$$%STUBLIBDIR=\$$(PREFIX)/lib/ocaml/stublibs%g"

%:
	dh $@

ocamlinit-stamp: $(TARBALL_TARGET)

# Generate ocaml-native-compilers' Architecture field.
# Should never be called automatically.
.PHONY: debian/control
debian/control:
	sed -e 's/@OCamlNativeArchs@/$(OCAML_NATIVE_ARCHS)/g' debian/control.in > $@

pre-config-stamp: $(TARBALL_TARGET)
	chmod +x debian/gen_modules.pl
# Backup upstream config.{sub,guess}, and use most up-to-date ones
	for ext in sub guess; do \
	  if [ -f /usr/share/misc/config.$$ext ] && \
	    ! [ -f debian/config.orig.$$ext ]; then \
	    mv config/gnu/config.$$ext debian/config.orig.$$ext; \
	    cp -f /usr/share/misc/config.$$ext config/gnu/config.$$ext; \
	  fi; \
	done
	touch $@

ifneq (,$(TARBALL_TARGET))
$(TARBALL_TARGET):
# Make a copy of the current (patched) sources in debian/$(DISTDIR)
	ln -fs . $(DISTDIR)	# beware of the symlink recursion!
	mkdir debian/$(DISTDIR)
	tar --anchored -ch \
	  --exclude=$(DISTDIR)/$(DISTDIR)	\
	  --exclude-from=debian/ocaml-source.exclude \
	  $(DISTDIR)/ | tar -C debian -x
	rm -f $(DISTDIR)
# Copy patches and unapply them
	cp -a debian/patches debian/$(DISTDIR)/debian-patches
	cd debian/$(DISTDIR) && sort -r debian-patches/series | \
	while read u; do \
	  patch -R -V never -p1 < debian-patches/$$u; \
	done
# Create the tarball and cleanup
	tar -C debian -cjf $@ $(DISTDIR)
	rm -Rf debian/$(DISTDIR)
endif

.PHONY: override_dh_auto_configure
override_dh_auto_configure: config-stamp

config-stamp: pre-config-stamp ocamlinit-stamp
	./configure $(CONFIGURE_OPTS)
	sed -i $(CONFIGURE_SED) config/Makefile
	if test -z "`grep "OTHERLIBRARIES.*labltk" config/Makefile`"; then \
	  echo "Error, labltk library was not detected"; \
	  echo "Check your tcl/tk development packages"; \
	  echo "Aborting."; \
	  exit 1; \
	fi
	touch $@

.PHONY: override_dh_auto_build
override_dh_auto_build: build-stamp

build-stamp: config-stamp
	if test ! -d boot.debian; then \
	  cp -xa boot boot.debian; \
	fi
	rm -Rf debian/examples && mkdir debian/examples
	cp -a otherlibs/labltk/examples_labltk debian/examples/labltk
	find debian/examples/labltk -name .cvsignore -delete
ifeq ($(BUILDCACHE),)
	$(MAKE) world
	$(MAKE) bootstrap
	$(MAKE) -C tools dumpobj
ifeq (,$(OCAML_OPT_ARCH))
# As of 3.11.0, manpages are made only in `make opt.opt'
	make -C ocamldoc manpages \
	  OCAMLDOC_RUN="../boot/ocamlrun -I ../otherlibs/unix -I ../otherlibs/str ./ocamldoc"
else
	@echo "Building native compilers"
	$(MAKE) opt opt.opt
	touch opt-built-stamp
endif
else
	@echo "===> WARNING: $(BUILDCACHE) detected, compilation skipped! <==="
	rsync -a --exclude=debian --exclude=.git $(BUILDCACHE)/ .
	rm -f build-stamp install-stamp
endif
	touch $@

.PHONY: override_dh_auto_clean
override_dh_auto_clean: ocamlinit-clean
ifneq ($(wildcard $(CURDIR)/config/Makefile),)
	$(MAKE) clean
	$(MAKE) -C emacs clean
endif
# Restore files altered by the build process
	if test -d boot.debian; then \
	  rm -Rf boot; \
	  mv boot.debian boot; \
	fi
	for ext in sub guess; do \
	  if [ -f debian/config.orig.$$ext ] ; then \
	    mv -f debian/config.orig.$$ext config/gnu/config.$$ext; \
	  fi; \
	done
	if head -n 1 emacs/ocamltags.in | grep -q '^#!/bin/sh'; then \
		sed -i 1d emacs/ocamltags.in; \
	fi
# Remaining stuff
	-rm -Rf debian/$(SRCTARBALL) debian/examples

.PHONY: override_dh_auto_install
override_dh_auto_install: install-stamp

install-stamp:
ifneq (,$(findstring ocaml-mode,$(ALL_PACKAGES)))
# Install Emacs files
	$(MAKE) -C emacs \
	  EMACSDIR=$(CURDIR)/debian/ocaml-mode/usr/share/emacs/site-lisp/ocaml-mode \
	  NOCOMPILE=true simple-install
	if ! head -n 1 emacs/ocamltags.in | grep -q '^#!/bin/sh'; then \
	  sed -i -e '1 i #!/bin/sh' emacs/ocamltags.in; \
	fi
	$(MAKE) -C emacs SCRIPTDIR=$(CURDIR)/debian/ocaml-mode/usr/bin install-ocamltags
endif
# Install OCaml
	sed -e 's|PREFIX=\"/.*\"|PREFIX=\"$(INSTDIR)"|' < config/config.sh > config/config.debian.install.sh
	$(MAKE) install PREFIX=$(INSTDIR)
# Remove empty directory
	rmdir $(CURDIR)/debian/tmp$(OCAML_STDLIB_DIR)/ocamldoc/custom
# To avoid erroneous dh_install warnings
	rm -f $(INSTDIR)/share/man/man1/ocamlopt.opt.1 $(INSTDIR)/share/man/man1/ocamlc.opt.1
# Dispatch files with dh_install
	cd debian && \
	for u in ocaml ocaml-nox; do \
	  DESTDIR=tmp ./gen_modules.pl $$u.install > $$u.install.new; \
	  mv $$u.install.new $$u.install; \
	done
	if ! dh_install --list-missing; then \
	  echo "===> dh_install has failed <==="; \
	  find debian/tmp; \
	  exit 1; \
	fi
# Install additional files not handled by dh_install
# Beware: dh_install does not handle renamings, please pay attention
	cp otherlibs/labltk/README debian/ocaml/usr/share/doc/ocaml/README.labltk
	for u in dumpobj; do \
	  if [ -f tools/$$u ]; then \
	    cp tools/$$u debian/ocaml-nox/usr/bin/ocaml$$u; \
	  fi \
	done
	for mli in `find camlp4 -name '*.mli'` ; do \
	  cp --parents $$mli debian/camlp4$(OCAML_STDLIB_DIR); \
	done
	for pkg in ocaml ocaml-nox ocaml-base; do ( \
	  cd debian/$$pkg/usr/share/doc/$$pkg && \
	  ln -sf ../ocaml-base-nox/README.gz . && \
	  ln -sf ../ocaml-base-nox/README.Debian .; \
	); done
# Remaining stuff
	touch $@

.PHONY: override_dh_compress
override_dh_compress:
	dh_compress -Xexamples/labltk

.PHONY: override_dh_gencontrol
override_dh_gencontrol:
	for u in $(ALL_PACKAGES); do \
	  echo 'F:OCamlABI=$(OCAML_ABI)' >> debian/$$u.substvars; \
	done
ifeq (,$(OCAML_OPT_ARCH))
	echo 'F:BestProvides=ocaml-best-compilers' >> debian/ocaml-nox.substvars
else
	echo 'F:BestProvides=' >> debian/ocaml-nox.substvars
endif
# Create .md5sums files and compute dependencies. Use $(OCAML_ABI)
# because we know that OCaml ABI represents best dependencies for
# OCaml package.
	dh_ocaml -Xcompiler-libs -Xcamlp4-extra \
	 --runtime-map ocaml-nox:ocaml-base-nox,ocaml:ocaml-base,camlp4 \
	 --checksum $(OCAML_ABI)
	dh_gencontrol
# Check that OCAML_ABI is correct
	if [ "$(OCAML_ABI)" != "$(shell boot/ocamlrun ./ocamlc -version | { read a && echo $${a%%_*}; })" ]; then \

=== debian/watch ===
version=3
opts=uversionmangle=s/\+/~/ \
http://caml.inria.fr/pub/distrib/ocaml-([\d\.]+)/ocaml-([^-]+)\.tar\.gz
